# -*- coding: UTF-8 -*-

import json


def get_tags():
    return ['1', '1.1']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars[
        "scancommand1"] = r'''result=$(ps -ef| grep -Ev 'grep|controller'|grep elasticsearch| awk -F 'Des.path.home=' '{print $2}'|awk '{print $1}');if [ -n $result ];then cd $result;result=$(ls lib|grep -P 'elasticsearch-\d\.\d\.\d\.jar');echo $result;else echo "" ;fi;'''

    tmp_vars["systemvalue1"] = ""
    ret_code = 0

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    version = ''
    if astdout1 != '':
        version_index_start = astdout1.index('-') + 1
        version_index_end = astdout1.index('.jar')
        version = astdout1[version_index_start: version_index_end]

    if version is None or version == '':
        ret_code = -1
        tmp_vars["systemvalue1"] = "no version"
    elif version < '7.6.5':
        ret_code = -1
        tmp_vars["systemvalue1"] = "version is " + version
    else:
        ret_code = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = "version is" + version

    if tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_1_1.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
