# -*- coding: UTF-8 -*-

import json


def get_tags():
    return ['1', '1.5']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r"result=$(ps -ef| grep -Ev 'grep|controller'|grep elasticsearch| awk -F 'Des.path.home=' '{print $2}'|awk '{print $1}');if [ -n $result ];then cd $result;result=$(grep 'opendistro_security.ssl.transport.keystore_password' config/elasticsearch.yml|grep -v '#'|awk -F ':' '{print $2}');echo $result;else echo "" ;fi;"
    tmp_vars["systemvalue1"] = ""
    ret_code = 0

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]

    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = r"result=$(ps -ef| grep -Ev 'grep|controller'|grep elasticsearch| awk -F 'Des.path.home=' '{print $2}'|awk '{print $1}');if [ -n $result ];then cd $result;result=$(grep 'opendistro_security.ssl.transport.truststore_password' config/elasticsearch.yml|grep -v '#'|awk -F ':' '{print $2}');echo $result;else echo "" ;fi;"
    tmp_vars["systemvalue2"] = ""
    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand2"])
    arc2, astdout2, astderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc2, astdout2, astderr2)
    runcontext.sleep()

    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)

    if astdout1 is None or astdout1 == '':
        ret_code1 = -1
        tmp_vars["systemvalue1"] = "未配置节点间加固"
    else:
        ret_code1 = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1

    if astdout2 is None or astdout2 == '':
        ret_code2 = -1
        tmp_vars["systemvalue2"] = "未配置节点间加固"
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = astdout2
        ret_code2 = 0

    if ret_code1 == 0 and ret_code2 == 0:
        ret_code = 0
    else:
        ret_code = -1

    if tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass":
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_1_5.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
